package grade;

import org.junit.jupiter.api.Test;
import task1.BinaryTree;

import static org.junit.jupiter.api.Assertions.assertFalse;
import static org.junit.jupiter.api.Assertions.assertTrue;

public class BinaryTreeTest {

  @Test
  void example1() {
    /*
     *     2
     *    / \
     *   1   3
     */
    Integer[] input = new Integer[]{2, 1, 3};
    assertTrue(BinaryTree.isValidBst(input));
  }

  @Test
  void example2() {
    /*
     *     5
     *    / \
     *   1   4
     *      / \
     *     3   6
     */
    Integer[] input = new Integer[]{5, 1, 4, null, null, 3, 6};
    assertFalse(BinaryTree.isValidBst(input));
  }

  // TODO add more tests.

  @Test
  void example3() {
    /*
     *      5
     *    /   \
     *   1     6
     *    \   / \
     *     7 3   8
     */
    Integer[] input = new Integer[]{5, 1, 6, null, 7, 3, 8};
    assertFalse(BinaryTree.isValidBst(input));
  }

  @Test
  void example4() {
    /*
     *      3
     *    /   \
     *   1     5
     *    \
     *     2
     *      \
     *       4
     */
    Integer[] input = new Integer[]{3, 1, 5, null, 2, null, null, null, 4};
    assertFalse(BinaryTree.isValidBst(input));
  }

}